<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.1" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format" xmlns:msxsl="urn:schemas-microsoft-com:xslt" xmlns:inr="http://mycompany.com/mynamespace">
    <xsl:include href="../format.xsl"/>
    <xsl:param name="xslRootDirectory" select="inr:xslRootDirectory"/>
    <!-- Nikon Export Format Report -->
    <xsl:output method="text" media-type="text/plain" encoding="iso-8859-1"/>
    <xsl:template match="/">
        <xsl:variable name="gridOut" select="inr:SetGridOut(number(InRoads/@outputGridScaleFactor))"/>
        <xsl:choose>
            <xsl:when test="$xslShowHelp = 'true'">
                <xsl:call-template name="StyleSheetHelp"/>
            </xsl:when>
            <xsl:otherwise>
                <xsl:for-each select="InRoads/SurveyFieldbook/SurveyPointList">
                    <xsl:text/>
                    <xsl:for-each select="SurveyPoint">
                        <xsl:text>MC,</xsl:text>
                        <xsl:value-of select="@name"/>
                        <xsl:text>,</xsl:text>
                        <xsl:value-of select="@code"/>
                        <xsl:text>,</xsl:text>
                        <xsl:value-of select="inr:northingFormat(number(@northing), 4)"/>
                        <xsl:text>,</xsl:text>
                        <xsl:value-of select="inr:eastingFormat(number(@easting), 4)"/>
                        <xsl:text>,</xsl:text>
                        <xsl:value-of select="inr:elevationFormat(number(@elevation), 4)"/>
                        <xsl:text>,</xsl:text>
                        <xsl:value-of select="@code"/>
                        <xsl:text>&#xd;</xsl:text>
                    </xsl:for-each>
                </xsl:for-each>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    <xsl:template name="StyleSheetHelp">
        <xsl:text>Notes&#xd;&#xd;</xsl:text>
        <xsl:text>    You must select at least one fieldbook in the Survey &gt;&#xd;</xsl:text>
        <xsl:text>    XML Report command to get results from this report.&#xd;&#xd;</xsl:text>
        <xsl:text>    Your fieldbook must contain data for a complete report.&#xd;&#xd;</xsl:text>
        <xsl:text>    This report emulates the Text Export Wizard called&#xd;</xsl:text>
        <xsl:text>    nikon.tew.&#xd;&#xd;</xsl:text>
        <xsl:text>Copyright 2006 Bentley Systems, Inc&#xd;</xsl:text>
    </xsl:template>
</xsl:stylesheet>
