<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.1" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format" xmlns:msxsl="urn:schemas-microsoft-com:xslt" xmlns:inr="http://mycompany.com/mynamespace">
    <xsl:include href="../format.xsl"/>
    <!-- Roadway Design Superelevation Stations to Event Points -->
    <xsl:output method="text" media-type="text/plain" encoding="iso-8859-1"/>
    <xsl:template match="/">
        <xsl:variable name="gridOut" select="inr:SetGridOut(number(InRoads/@outputGridScaleFactor))"/>
        <xsl:choose>
            <xsl:when test="$xslShowHelp = 'true'">
                <xsl:call-template name="StyleSheetHelp"/>
            </xsl:when>
            <xsl:otherwise>
                <xsl:for-each select="InRoads/RoadwayDesigner/Corridor[SuperStationEvent]">
                    <xsl:text/>
                    <xsl:text>* Corridor </xsl:text><xsl:value-of select="@name"/><xsl:text>&#xd;</xsl:text>
                    <xsl:text>* Station           Offset    Style&#xd;</xsl:text>
                    <xsl:text>*&#xd;</xsl:text>
                    <xsl:for-each select="SuperStationEvent">
                        <xsl:value-of select="inr:columnFormat(string(inr:stationFormat(number(@externalStation), $xslStationFormat, $xslStationPrecision, string(@externalStationName))), 16)"/>
                        <xsl:text>    0.0000    super&#xd;</xsl:text>
                    </xsl:for-each>
                </xsl:for-each>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    <xsl:template name="StyleSheetHelp">
        <xsl:text>Notes&#xd;&#xd;</xsl:text>
        <xsl:text>    You must open a Roadway Design file by selecting File &gt;&#xd;</xsl:text>
        <xsl:text>    Open on the Report Browser menu and setting the Files&#xd;</xsl:text>
        <xsl:text>    of type field to Roadway Design (*.ird).&#xd;&#xd;</xsl:text>
        <xsl:text>    You must also have at least one corridor defined in the&#xd;</xsl:text>
        <xsl:text>    Modeler &gt; Roadway Designer &gt; Corridor &gt; Corridor&#xd;</xsl:text>
        <xsl:text>    Manager command and you must have defined super-&#xd;</xsl:text>
        <xsl:text>    elevation for the horizontal alignment and corridor&#xd;</xsl:text>
        <xsl:text>    upon which you wish to report by selecting the Modeler&#xd;</xsl:text>
        <xsl:text>    &gt; Roadway Designer &gt; Superelevation &gt; Create&#xd;</xsl:text>
        <xsl:text>    Superelevation Wizard command.&#xd;&#xd;</xsl:text>
        <xsl:text>Copyright 2006 Bentley Systems, Inc&#xd;</xsl:text>
    </xsl:template>
</xsl:stylesheet>
