<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.1" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format" xmlns:msxsl="urn:schemas-microsoft-com:xslt" xmlns:inr="http://mycompany.com/mynamespace">
    <xsl:include href="../format.xsl"/>
    <!-- XIN to SDR Format -->
    <xsl:output method="text" media-type="text/plain" encoding="iso-8859-1"/>
    <xsl:template match="/">
        <xsl:variable name="gridOut" select="inr:SetGridOut(number(InRoads/@outputGridScaleFactor))"/>
        <xsl:choose>
            <xsl:when test="$xslShowHelp = 'true'">
                <xsl:call-template name="StyleSheetHelp"/>
            </xsl:when>
            <xsl:otherwise>
                <xsl:for-each select="CivilIni/FeatureStyleCollection">
                    <xsl:for-each select="FeatureStyle">
                        <xsl:for-each select="SurveyFeature">
                            <xsl:for-each select="AlphaCode">
                                <xsl:text>13FC</xsl:text><xsl:value-of select="@Code"/><xsl:text>&#xd;</xsl:text>
                            </xsl:for-each>
                        </xsl:for-each>
                    </xsl:for-each>
                </xsl:for-each>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    <xsl:template name="StyleSheetHelp">
        <xsl:text>Notes&#xd;&#xd;</xsl:text>
        <xsl:text>    You must open a Preferences file by selecting File &gt;&#xd;</xsl:text>
        <xsl:text>    Open on the Report Browser menu and setting the Files&#xd;</xsl:text>
        <xsl:text>    of type field to Preferences (*.xin).&#xd;&#xd;</xsl:text>
        <xsl:text>    Your Preferences file must contain Alpha Codes for your&#xd;</xsl:text>
        <xsl:text>    survey feature styles.&#xd;&#xd;</xsl:text>
        <xsl:text>Copyright 2006 Bentley Systems, Inc&#xd;</xsl:text>
    </xsl:template>
</xsl:stylesheet>
