<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format" xmlns:msxsl="urn:schemas-microsoft-com:xslt" xmlns:inr="http://mycompany.com/mynamespace">
    <xsl:param name="xslStationPrecision" select="3"/>
    <xsl:param name="xslDistancePrecision" select="3"/>
    <xsl:param name="xslNorthingPrecision" select="3"/>
    <xsl:param name="xslEastingPrecision" select="3"/>
    <xsl:param name="xslElevationPrecision" select="3"/>
    <xsl:param name="xslGradePrecision" select="2"/>
    <xsl:param name="xslAlternateSlopePrecision" select="0"/>
    <xsl:param name="xslDirectionPrecision" select="1"/>
    <xsl:param name="xslAngularPrecision" select="1"/>
    <xsl:param name="xslAcrePrecision" select="3"/>
    <xsl:param name="xslAreaPrecision" select="0"/>
    <xsl:param name="xslCubicPrecision" select="0"/>
    <!-- function templates -->
	<xsl:template name="Round">
		<xsl:param name="num"/>
		<xsl:param name="precision" select="2"/>
		<xsl:if test="$precision = 0">
			<xsl:value-of select="round($num)"/>
		</xsl:if>
		<xsl:if test="$precision = 1">
			<xsl:value-of select="round(10*$num) div 10"/>
		</xsl:if>
		<xsl:if test="$precision = 2">
			<xsl:value-of select="round(100*$num) div 100"/>
		</xsl:if>
		<xsl:if test="$precision= 3">
			<xsl:value-of select="round(1000*$num) div 1000"/>
		</xsl:if>
		<xsl:if test="$precision = 4">
			<xsl:value-of select="round(10000*$num) div 10000"/>
		</xsl:if>
		<xsl:if test="$precision = 5">
			<xsl:value-of select="round(100000*$num) div 100000"/>
		</xsl:if>
		<xsl:if test="$precision = 6">
			<xsl:value-of select="round(1000000*$num) div 1000000"/>
		</xsl:if>
		<xsl:if test="$precision = 7">
			<xsl:value-of select="round(10000000*$num) div 10000000"/>
		</xsl:if>
		<xsl:if test="$precision &lt; 0">
			<xsl:value-of select="round($num)"/>
		</xsl:if>
		<xsl:if test="$precision &gt; 7">
			<xsl:value-of select="round(10000000*$num) div 10000000"/>
		</xsl:if>
	</xsl:template>

</xsl:stylesheet>
