;----------------------------------------------------------------------
;
;  Bentley RasterImageProcessor (BSIRIP) Plotter Configuration file
;
;  Current Revision:
;  $RCSfile: rip_std_options.inc,v $
;  $Revision: 1.6.20.2 $  $Date: 2003/12/17 16:32:19 $
;
;----------------------------------------------------------------------

;======================================================================
;
;   >>>>> WARNING  WARNING  WARNING  WARNING  WARNING  WARNING  <<<<<
;  
;  Plotter driver configuration files are now stored in two directories:
;
;    $(_USTN_WORKSPACEROOT)/System/plotdrv/
;    $(_USTN_WORKSPACEROOT)/Standards/plotdrv/
;
;  System/plotdrv/ should be reserved for .plt files delivered by
;  MicroStation and other Bentley products. Standards/plotdrv/ is
;  provided as a place for you to store customized .plt files. To
;  simplify plotter selection from the Plot dialog, you may also
;  elect to store frequently-used .plt files in Standards/plotdrv/
;  even if you do not customize them.
;
;  To minimize the risk of losing your changes during a product
;  reinstallation, do not edit the files in the System/plotdrv/
;  directory. Instead, copy the necessary files to Standards/plotdrv/
;  and edit them there. If the .plt file depends on other files, such
;  as PostScript prolog (*.pro) files, copy them to the same directory.
;
;======================================================================

num_pens   = 255            ; Defines pens used
change_pen = both           ; options are color, weight, level or both
model      = MDL            ; plotter model number
driver     = bmf            ; MDL driver to use
autocenter                  ; Automatically center plot on page

; Use the below line if a border is desired.  When doing so you will
; need to add change the offset values in the below 'size' records to
; make room for the border. It may require some experimentation but a
; 1/4" is a good value to start with.
;
; available qualifiers 
;       /pen=n                  specifies pen to use to draw border
;                               * Omit this switch to use the default *
;       /time                   adds time and date to border
;       /filename               adds name of design file to border
;       /text_height=n          units are cm
;       /width=n                units are cm
;       /font="fontname"        e.g. "Arial"    
;                                   font names can be found by looking at 
;                                   StartMenu => Settings => ControlPanel => Fonts.
;                                   Note: a truetype font, like Arial, will scale 
;                                   better than a bitmap font like MS Sans Serif
border /time /filename /text_height=0.35 /width=0.026

; linecap, linejoin and miter_limit values
linecap     = 1         ; 1=butt, 2=square, 4=round
linejoin    = 5         ; 2=miter/bevel, 4=round, 5=beveled
miter_limit = 1.5       ; larger values mean longer spikes

; Construction/active points are not plotted by default. Uncomment the
; next line if you want points plotted. Points are plotted 0.1 cm dia.
; point_size = .1

; Specify the mapping of MicroStation line weights to line thickness on paper.
; Units are MM, IN, or DOTS (the default)
weight_strokes(mm)=(0.085, 0.169, 0.254, 0.339, 0.423, 0.508, 0.593, 0.677, \
                    0.762, 0.847, 0.931, 1.016, 1.101, 1.185, 1.270, 1.355, \
                    1.439, 1.524, 1.609, 1.693, 1.778, 1.863, 1.947, 2.032, \
                    2.117, 2.201, 2.286, 2.371, 2.455, 2.540, 2.625, 2.709)

; Stroke_tolerance determines tolerance for arcs and circles.  Value is
; between 0 and 10 with 10 being the greater tolerance.  Larger values
; also create larger plot files.
stroke_tolerance=10

;  Pen 0 is the 'background' pen.  Other pens get their color by default from
;  the corresponding color in the current design file color table.  The background
;  pen instead defaults to white.  To have the background pen get its value from
;  the master file color table, we assign it an RGB of(-1, -1, -1).
;
;pen(0)=/rgb=(-1, -1, -1)    ; get background pen color from master file background color

;  The style records defines how the design file line codes (styles)
;  are to be plotted.  Values are in plotter units (resolutions).
;  Values determine pen down/up movements, where (14,42) for a dot
;  pattern leaves the pen down for 14 units and up for 42 units.  The
;  /nohardware switch causes software stroking with these values.
; Units are MM, IN, or DOTS (the default)
style(1) = ( 0.35, 1.05)                         /hardware /units=MM ; style = dot
style(2) = ( 1.75, 1.05)                         /hardware /units=MM ; style = med dash
style(3) = ( 4.20, 1.40)                         /hardware /units=MM ; style = long dash
style(4) = ( 2.80, 1.05, 0.70, 1.05)             /hardware /units=MM ; style = dot-dash
style(5) = ( 1.40, 1.40)                         /hardware /units=MM ; style = short dash
style(6) = ( 2.10, 0.70, 0.70, 0.70, 0.70, 0.70) /hardware /units=MM ; style = dash-dot-dot
style(7) = ( 2.80, 0.70, 1.40, 0.70)             /hardware /units=MM ; style = long dash - short dash

largest_polygon=20000

; Specify the band size to use in the RIP. Larger numbers will increase
; performance of the RIP if that much memory is available.  Setting the
; value too large will resulting in memory swapping and actually slow 
; down the process. Default is 24 MB. 
CmdName /appname="bmf" /command="setBandSize" /qualifier="24M"

; specify the name of the area on disk that the RIP can use for scratch files
;----------------------------------------------------------------------------
; This line will set scratch to be the same as the normal plot output area
;CmdName /appname="bmf" /command="setScratchArea" /qualifier="$(ms_pltfiles)"
; This line will set scratch to be the same as the normal MicroStation TMP area (default)
CmdName /appname="bmf" /command="setScratchArea" /qualifier="$(ms_tmp)"

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; The following options control plotting of raster images
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; HARDWARE_RASTER (or SOFTWARE_RASTER) is used to plot raster element types 87 and 88.
; If HARDWARE_RASTER/RESOLUTION=0 below, type 87/88 raster elements are not plotted.
; Values for resolution can be as high as your plotter's resolution.  Lower values produce
; grainier images.

; Note: Most color devices must perform dithering to generate all the required
; colors when there are only 3 or 4 inks available. So setting raster resolution, 
; to a value greater than 1/2 (or even 1/4) of the plotter's resolution, may 
; not improve image quality and may increase the time required for plotting.

; If this line is omitted, or the resolution specified is not a legal value, a value of
; 1/2 of the plotter's resolution will be used.

; These parameters are also used by Raster Reference plotting.  For raster references, the
; plot resolution is the minimum of the image resolution and the resolution parameter
; specified below.
;
; Raster Manager and and Image Manager use other parameters to control the plot resolution,
; but use the resolution parameter below as a starting point.

    ; hardware_raster/resolution=150

; The following parameter controls the plot driver used by Image Manager, Descartes and
; Reprographics.  It is ignored by Raster Manager.  It must preceed the parameters below it.

MDLCOMMAND          = implot        ; For Image Manager (not needed by Raster Manager)
;MDLCOMMAND         = dcplot        ; For Descartes
;MDLCOMMAND         = replot        ; For ReproGraphics

; Raster Manager uses PIXEL_RESOLUTION to override HARDWARE_RASTER/RESOLUTION (above)
; Image Manager uses the smaller of the resolution values specified by PIXEL_RESOLUTION
; and HARDWARE_RASTER/RESOLUTION.

PIXEL_RESOLUTION    = 150           ; Resolution of pixels on output (dpi) Default=150
GRAYSCALE           = 0             ; Plot in gray scale,  1=On 0=Off      Default=0

; The following parameter can be used to specify the background color of monochrome raster
; in Raster Manager.  It is ignored by Image Manager.
; For BACKGROUND=0 or 1 (white or black), the raster foreground is inverted
; if it is identical to the background.
; For BACKGROUND=2 (color), no changes is made to the monochrome raster.

BACKGROUND          = 0             ; 0=white,1=black,2=color              Default=0

; The following parameters are used by both Image Manager and Raster Manager

CONTRAST            = 50            ; Contrast in percent, between 0-100   Default=50
BRIGHTNESS          = 50            ; Brightness in percent, between 0-100 Default=50

; The following parameters are used by Image Manager, but ignored by Raster Manager

ISV_RASTER          = 1             ; Plots the raster image,  1=On 0=Off  Default=1
RASTER_FENCE        = 0             ; Clip the raster to fence, 1=On 0=Off Default=0
NO_DGNRASTER        = 0             ; MS plot of 87/88, 1=Don't plot 0=Plot Default=0
NO_RASTERREF        = 0             ; MS plot of 90's,  1=Don't plot 0=Plot Default=0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

